;----------------------------------------------------------------
; JpegX Hidden Text Finder v0.2 (20 September 2002)
; Freeware, Open Source, GPL, Copyleft, whatever you want.
;----------------------------------------------------------------
;
; New in version 0.2:
;  - the lines breaks are taken in account, and just replaced
;    by spaces before the display, so they don't mess with the
;    window.
;
; It's just a very small utility, quick-and-dirty coded,
; to recover text "hidden" by JpegX steganography software 
; version 1.0.6. 
;
; How to use: run my program. Select the file with hidden 
; information data. That's all. You should see a MessageBox
; with two parts:
;
;  - a descrambled text, which will be the good one if no 
;    password was used
;
;  - a serie of brute-forced decrypted strings with printable
;    ASCII characters. Pick up the one which is intelligible.
;    It's not that brute, actually: whatever the password is,
;    there are just 256 possibilities. I just eliminate the 
;    text with unprintable character (32<okay<126, line breaks
;    0A and 0D are now okay)
;
; Guillermito
; guillermito@pipo.com
; http://www.guillermito.net
; September 18th 2002
;
; Assemble it with:
;      TASM32 /ml /m3 /z /t JpegX_Hidden_Text_Finder
;      TLINK32 -Tpe -aa JpegX_Hidden_Text_Finder,,,import32 


callW macro   x
extrn x:PROC
call x
endm

   .486
   .model flat

.data

openfilename_struct:
lStructSize       dd openfilename_struct_size
hwndOwner         dd 0
hInstance         dd 0
lpstrFilter       dd offset filter
lpstrCustomFilter dd 0
nMaxCustFilter    dd 0
nFilterIndex      dd 0
lpstrFile         dd offset namebuffer
nMaxFile          dd 255
lpstrFileTitle    dd 0
nMaxFileTitle     dd 32
lpstrInitialDir   dd 0
lpstrTitle        dd 0
Flags             dd 1000h+4h+200000h
nFileOffset       dw 0
nFileExtension    dw 0
lpstrDefExt       dd 0
lCustData         dd 0
lpfnHook          dd 0
lpTemplateName    dd 0
openfilename_struct_size equ $-offset openfilename_struct

text1             db "If there was no password, the hidden text was:", 0dh, 0Ah, 0dh, 0Ah
size_text1        equ $-offset text1
text2             db 0dh,0ah,"If there was a password, the hidden text was probably one of those:", 0dh, 0Ah, 0dh, 0Ah
size_text2        equ $-offset text2

filter            db "Jpg files *.jpg",0,"*.jpg",0,0
namebuffer	      db 255 dup(0)
result_title      db "JpegX hidden text is:", 0
not_found         db "This is probably not a JpegX carrier file",0

file_size          dd ?
file_handle        dd ?
file_mem_buffer    dd ?
file_nb_bytes_read dd ?
results            dd ?
hidden_text_start  dd ?
hidden_text_length dd ?
decrypted_text     dd ?

.code

programme:

;-------- choose a file -------------

push offset openfilename_struct
callW GetOpenFileNameA             ;choose file
test eax, eax
jz end

;-------- open it --------------

push 0
push 80h                          ;FILE_ATTRIBUTE_NORMAL
push 3                            ;OPEN_EXISTING
push 0
push 0
push 80000000h+40000000h          ;GENERIC_READ+GENERIC_WRITE
push dword ptr [lpstrFile]
callW CreateFileA                 ;open file
inc eax
jz end
dec eax
mov file_handle, eax

;---------- get its size ---------

push 0
push dword ptr file_handle
callW GetFileSize                 ;get file size in bytes
inc eax
jz close_file
dec eax
mov file_size, eax

;--------- alloc memory for file --------

mov eax, file_size
add eax, 1024*1024
push eax                         ;number of bytes to allocate
push 40h                         ;40h=LMEM_ZEROINIT
callW LocalAlloc
test eax, eax
jz close_file
mov file_mem_buffer, eax
add eax, file_size
add eax, 1024
mov results, eax

;------- read entire file ------------

push 0
push offset file_nb_bytes_read
push file_size
push file_mem_buffer
push file_handle
callW ReadFile
test eax, eax
jz free_memory
mov eax, file_nb_bytes_read
cmp eax, file_size
jnz free_memory

;-------- find JpegX signature ---------

mov ecx, file_size
mov esi, file_mem_buffer

search_loop:
mov eax, dword ptr [esi]
cmp eax, "nraW"
je maybe1
come_back:
inc esi
loop search_loop

;-------- not found -----------

push 0
push offset not_found
push offset not_found
push 0
callW MessageBoxA
jmp free_memory

;------ check more -----------

maybe1:
mov eax, dword ptr [esi+4]
cmp eax, "!gni"
je maybe2
jmp come_back

maybe2:
mov eax, dword ptr [esi+8]
cmp eax, "doM "
je maybe3
jmp come_back

maybe3:
mov eax, dword ptr [esi+28]
cmp eax, "if s"
je maybe4
jmp come_back

maybe4:
mov eax, dword ptr [esi+68]
cmp eax, " .gn"
je maybe5
jmp come_back

maybe5:
mov eax, dword ptr [esi+73]
cmp eax, "XgeP"
je now_we_are_sure
jmp come_back

;------ get the length of the hidden text --------

now_we_are_sure:
add esi, 83
xor ecx, ecx
mov word ptr cx, [esi]
mov hidden_text_length, ecx

;----- descramble the hidden text ---------

add esi, 2
mov hidden_text_start, esi
xor edx, edx
mov edi, results

   ;write the first message
   push ecx
   push esi
   mov esi, offset text1
   mov ecx, size_text1
   rep movsb
   pop esi
   pop ecx
 
mov decrypted_text, edi

decrypt_loop:
lodsb
sub al, 0bbh
sbb al, 0
sub al, dl
sbb al, 0
inc dl
dont_replace:
stosb
loop decrypt_loop
mov ax, 0d0ah
stosw

   ;write the second message
   mov esi, offset text2
   mov ecx, size_text2
   rep movsb
  
;------ try to decrypt it with a password --------

mov ebx, 0ffh

all_passwords_loop:

mov esi, decrypted_text
mov ecx, hidden_text_length
mov edx, ebx

one_password_loop:
lodsb
sub al, dl
sbb al, 0

    ;eliminate if no printable character
    ;transform line breaks into spaces
    cmp al, 0dh
    jne next_check3
    mov al, 32
    next_check3:
    cmp al, 0Ah
    jne next_check4
    mov al, 32
    next_check4:
    cmp al, 126
    ja not_in_the_range
    cmp al, 32
    jb not_in_the_range

stosb
add dl, 1
adc dl, 0
loop one_password_loop
mov ax, 0d0ah
stosw

end_loop:
dec ebx
jz stop_the_loops
jmp all_passwords_loop

not_in_the_range:
mov eax, hidden_text_length
sub eax, ecx
sub edi, eax
jmp end_loop

stop_the_loops:

;------- remove any 0 that will stop the display -------

mov ecx, edi
sub ecx, results
mov esi, results

remove_zero_loop:
lodsb
cmp al, 0
jne no_zero
mov al, 32
mov edi, esi
dec edi
stosb
no_zero:
loop remove_zero_loop
mov eax, 0
mov edi, esi
stosb

;-------- show the stuff -----------

push 0
push offset result_title
push results
push 0
callW MessageBoxA

;------- close memory and file ----------------

free_memory:
push file_mem_buffer
callW LocalFree

;----------- exit ----------

close_file:
push dword ptr file_handle
callW CloseHandle

end:
push -1
callW ExitProcess

end programme
